# PROCESS MADELON DATA - STAGE 3.

# Get ARD hyperparameters from MCMC run for neural net models.

hypers.nn.all <- 
  read.matrix(pipe("net-tbl h1@ nn-all.log 41:"),ncol=nvars)
hypers.nn.sel <- 
  read.matrix(pipe("net-tbl h1@ nn-sel.log 41:"),ncol=length(ix.sel))

# Compute overall relevance of variables from ARD hyperparameters.

qnt <- function (x) quantile(x,0.75)

rel.nn.all <- apply(hypers.nn.all,2,qnt) * 
              apply(train.x,2,sd)

rel.nn.sel <- apply(hypers.nn.sel,2,qnt) * 
              apply(train.x[,ix.sel],2,sd)

# Plot these relevances.

postscript("madelon3a.ps",horizontal=TRUE)

par(mfrow=c(1,3))

plot(rel.nn.sel,pch=20,log="y")

plot(rel.nn.all,pch=20,log="y")
points(ix.sel,rel.nn.all[ix.sel],pch=20,col="red")

plot(rel.nn.sel,rel.nn.all[ix.sel],pch=20,log="xy")

dev.off()

# Find a reduced set of features based on these relevances.

ix.red <- union (ix.sel[order(-rel.nn.sel)[1:15]], order(-rel.nn.all)[1:15])

write.ix(ix.red,"red")
write.data(ix.red,"red")
